# ShipStation API v2

Version: 2.0.0
License: MIT

## Servers

Production
```
https://api.shipstation.com
```

## Security

### api_keys

Generate your secret API key in the app settings.


Type: apiKey
In: header
Name: api-key

## Download OpenAPI description

[ShipStation API v2](https://docs.shipstation.com/_bundle/apis/@shipstation-v2/openapi.yaml)

## Account

Manage account settings, including label image preferences and configurations.


### List account settings

 - [GET /v2/account/settings](https://docs.shipstation.com/apis/openapi/account/list_account_settings.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

List all account settings for the ShipStation API account

### List account images

 - [GET /v2/account/settings/images](https://docs.shipstation.com/apis/openapi/account/list_account_images.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

List all account images for the ShipStation API account

### Create an account image

 - [POST /v2/account/settings/images](https://docs.shipstation.com/apis/openapi/account/create_account_image.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Create an account image

### Get account image by ID

 - [GET /v2/account/settings/images/{label_image_id}](https://docs.shipstation.com/apis/openapi/account/get_account_settings_images_by_id.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Retrieve information for an account image

### Update account image by ID

 - [PUT /v2/account/settings/images/{label_image_id}](https://docs.shipstation.com/apis/openapi/account/update_account_settings_images_by_id.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Update information for an account image

### Delete account image by ID

 - [DELETE /v2/account/settings/images/{label_image_id}](https://docs.shipstation.com/apis/openapi/account/delete_account_image_by_id.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Delete account image by ID

## Addresses

Validate shipping addresses to ensure accuracy and improve delivery success rates.


### Validate an address

 - [POST /v2/addresses/validate](https://docs.shipstation.com/apis/openapi/addresses/validate_address.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Address validation ensures accurate addresses and can lead to reduced shipping costs by preventing address correction surcharges.
ShipStation API cross references multiple databases to validate addresses and identify potential deliverability issues.

## Batches

Process labels in bulk and receive a large number of labels and customs forms in bulk responses. Batching is ideal for workflows that need to process hundreds or thousands of labels quickly.


### List batches

 - [GET /v2/batches](https://docs.shipstation.com/apis/openapi/batches/list_batches.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

List the batches associated with your ShipStation account.

### Create a batch

 - [POST /v2/batches](https://docs.shipstation.com/apis/openapi/batches/create_batch.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Create a batch containing multiple labels.

### Get batch by external id

 - [GET /v2/batches/external_batch_id/{external_batch_id}](https://docs.shipstation.com/apis/openapi/batches/get_batch_by_external_id.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Retreive a batch using an external batch ID

### Delete batch by id

 - [DELETE /v2/batches/{batch_id}](https://docs.shipstation.com/apis/openapi/batches/delete_batch.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Delete a batch based on its batch id. Sets its status to 'archived'.

### Get batch by id

 - [GET /v2/batches/{batch_id}](https://docs.shipstation.com/apis/openapi/batches/get_batch_by_id.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Get batch details for a specific batch id.

### Update batch status to 'archived' by id

 - [PUT /v2/batches/{batch_id}](https://docs.shipstation.com/apis/openapi/batches/update_batch.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Update a batch by id setting its status to 'archived'.

### Add to a batch

 - [POST /v2/batches/{batch_id}/add](https://docs.shipstation.com/apis/openapi/batches/add_to_batch.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Add a shipment or rate to a batch.

### Get batch errors

 - [GET /v2/batches/{batch_id}/errors](https://docs.shipstation.com/apis/openapi/batches/list_batch_errors.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Errors in batches must be handled differently from synchronous requests. You must retrieve the status of your batch by getting a batch and getting an overview of the statuses or by listing the batch errors.

### Process batch id labels

 - [POST /v2/batches/{batch_id}/process/labels](https://docs.shipstation.com/apis/openapi/batches/process_batch.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Create and purchase the labels for the shipments included in the batch.

### Remove from batch

 - [POST /v2/batches/{batch_id}/remove](https://docs.shipstation.com/apis/openapi/batches/remove_from_batch.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Remove specific shipment ids or rate ids from a batch.

## Carriers

Retreive useful details about the carriers connected to your accounts, including carrier IDs, service IDs, advanced options, and available carrier package types.


### List carriers

 - [GET /v2/carriers](https://docs.shipstation.com/apis/openapi/carriers/list_carriers.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

List all carriers that have been added to this account.

### Get carrier by id

 - [GET /v2/carriers/{carrier_id}](https://docs.shipstation.com/apis/openapi/carriers/get_carrier_by_id.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Retrive details about a specific carrier by its carrier id.

### Disconnect carrier by id

 - [DELETE /v2/carriers/{carrier_id}](https://docs.shipstation.com/apis/openapi/carriers/disconnect_carrier_by_id.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Disconnect a carrier from the account by its carrier id.

### Add funds to carrier

 - [PUT /v2/carriers/{carrier_id}/add_funds](https://docs.shipstation.com/apis/openapi/carriers/add_funds_to_carrier.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Add funds to a carrier account.

### Get carrier options

 - [GET /v2/carriers/{carrier_id}/options](https://docs.shipstation.com/apis/openapi/carriers/get_carrier_options.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Get a list of the options available for a specific carriers.

### List carrier package types

 - [GET /v2/carriers/{carrier_id}/packages](https://docs.shipstation.com/apis/openapi/carriers/list_carrier_package_types.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

List the package types associated with a specific carrier.

### List carrier services

 - [GET /v2/carriers/{carrier_id}/services](https://docs.shipstation.com/apis/openapi/carriers/list_carrier_services.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

List the services associated with a specific carrier id.

## Connections

Manage carrier connections, including adding new carriers, updating settings, and managing payment information.


### Connect a carrier account

 - [POST /v2/connections/carriers/{carrier_name}](https://docs.shipstation.com/apis/openapi/connections/connect_carrier.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Connect a carrier account

### Disconnect a carrier

 - [DELETE /v2/connections/carriers/{carrier_name}/{carrier_id}](https://docs.shipstation.com/apis/openapi/connections/disconnect_carrier.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Disconnect a carrier

### Get carrier settings

 - [GET /v2/connections/carriers/{carrier_name}/{carrier_id}/settings](https://docs.shipstation.com/apis/openapi/connections/get_carrier_settings.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Get carrier settings

### Update carrier settings

 - [PUT /v2/connections/carriers/{carrier_name}/{carrier_id}/settings](https://docs.shipstation.com/apis/openapi/connections/update_carrier_settings.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Update carrier settings

## Downloads

Download your label files in PDF, PNG, and ZPL.


### Download file

 - [GET /v2/downloads/{dir}/{subdir}/{filename}](https://docs.shipstation.com/apis/openapi/downloads/download_file.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Download labels and other shipment-related documents.

## Fulfillments

Manage fulfillments which represent completed shipments. Create fulfillments to mark orders as shipped with tracking information and notify customers and marketplaces.


### List fulfillments

 - [GET /v2/fulfillments](https://docs.shipstation.com/apis/openapi/fulfillments/list_fulfillments.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Retrieve a list of fulfillments based on various filter criteria. You can filter by shipment details,
tracking information, dates, and more to find the specific fulfillments you need.

### Create fulfillments

 - [POST /v2/fulfillments](https://docs.shipstation.com/apis/openapi/fulfillments/create_fulfillments.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Create one or more fulfillments by marking shipments as shipped with tracking information.
This will notify customers and marketplaces according to your configuration.

## Inventory

Manage inventory levels, warehouses, and locations.


### List SKU inventory levels

 - [GET /v2/inventory](https://docs.shipstation.com/apis/openapi/inventory/getinventorylevels.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans

### Update SKU stock levels and related properties

 - [POST /v2/inventory](https://docs.shipstation.com/apis/openapi/inventory/updateskustocklevels.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans

### List all inventory warehouses

 - [GET /v2/inventory_warehouses](https://docs.shipstation.com/apis/openapi/inventory/getinventorywarehouses.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans

### Create a new inventory warehouse

 - [POST /v2/inventory_warehouses](https://docs.shipstation.com/apis/openapi/inventory/addnewinventorywarehouse.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans

### Get a specific inventory warehouse and related properties using its warehouse ID

 - [GET /v2/inventory_warehouses/{inventory_warehouse_id}](https://docs.shipstation.com/apis/openapi/inventory/getinventorywarehousebyid.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans

### Update an inventory warehouse name

 - [PUT /v2/inventory_warehouses/{inventory_warehouse_id}](https://docs.shipstation.com/apis/openapi/inventory/updateinventorywarehouse.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans

### Delete an inventory warehouse

 - [DELETE /v2/inventory_warehouses/{inventory_warehouse_id}](https://docs.shipstation.com/apis/openapi/inventory/deleteinventorywarehouse.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans

### List all inventory locations

 - [GET /v2/inventory_locations](https://docs.shipstation.com/apis/openapi/inventory/listinventorylocations.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans

### Create a new inventory location

 - [POST /v2/inventory_locations](https://docs.shipstation.com/apis/openapi/inventory/createinventorylocation.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans

### Get inventory location by ID

 - [GET /v2/inventory_locations/{inventory_location_id}](https://docs.shipstation.com/apis/openapi/inventory/getinventorylocationbyid.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans

### Update an inventory location

 - [PUT /v2/inventory_locations/{inventory_location_id}](https://docs.shipstation.com/apis/openapi/inventory/updateinventorylocation.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans

### Delete an inventory location

 - [DELETE /v2/inventory_locations/{inventory_location_id}](https://docs.shipstation.com/apis/openapi/inventory/deleteinventorylocationbyid.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans

## Labels

Purchase and print shipping labels for any carrier active on your account. The labels endpoint also supports creating return labels, voiding labels, and getting label details like tracking.


### Created combined label document

 - [POST /v2/documents/combined_labels](https://docs.shipstation.com/apis/openapi/labels/create_combined_label_document.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Download a combined label file

### List labels

 - [GET /v2/labels](https://docs.shipstation.com/apis/openapi/labels/list_labels.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

This method returns a list of labels that you've created. You can optionally filter the results as well as control their sort order and the number of results returned at a time.

By default all labels are returned 25 at a time, starting with the most recently created ones. You can combine multiple filter options to narrow-down the results.  For example, if you only want your UPS labels for your east coast warehouse you could query by both warehouse_id and carrier_id.

### Purchase label

 - [POST /v2/labels](https://docs.shipstation.com/apis/openapi/labels/create_label.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Purchase and print a label for shipment.

### Purchase label with rate id

 - [POST /v2/labels/rates/{rate_id}](https://docs.shipstation.com/apis/openapi/labels/create_label_from_rate.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

When retrieving rates for shipments using the /rates endpoint, the returned information contains a rate_id property that can be used to generate a label without having to refill in the shipment information repeatedly.

### Purchase label with shipment id

 - [POST /v2/labels/shipment/{shipment_id}](https://docs.shipstation.com/apis/openapi/labels/create_label_from_shipment.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Purchase a label using a shipment ID that has already been created with the desired address and package info.

### Purchase label with rate shopper

 - [POST /v2/labels/rate_shopper_id/{rate_shopper_id}](https://docs.shipstation.com/apis/openapi/labels/create_label_from_rate_shopper.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Create a label using Rate Shopper to automatically select the best
carrier and service based on the specified strategy or custom rate
shopper configuration.

You can use a standard strategy (cheapest, fastest, best_value)
or pass a custom rate shopper ID (service collection GUID) to use your
own configured service collection for rate selection.

For more information about Rate Shopper strategies and use cases, see Rate Shopping.

### Purchase label with shipping rule

 - [POST /v2/labels/shipping_rules/{shipping_rule_id}](https://docs.shipstation.com/apis/openapi/labels/create_label_from_shipping_rule.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Purchase and print a shipping label using a Shipping Rule. The Shipping Rule automatically selects the optimal carrier and service based on the rule's configuration.

Dynamic Ordering: Service Group Rules can now use dynamic ordering (_Cheapest_ or _Fastest_) to automatically rank eligible services in real time based on live rate or transit data. This feature is currently available for US sellers with USA domestic carrier services only. For more details, see the Configuring "Order Services By" guide.

The request body must NOT include carrier_id, service_code, or shipping_rule_id in the shipment object. If any of these fields are provided, the API will return a 400 Bad Request error.

### Get label by id

 - [GET /v2/labels/{label_id}](https://docs.shipstation.com/apis/openapi/labels/get_label_by_id.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Retrieve a specific label by its label id.

### Get label by external shipment ID

 - [GET /v2/labels/external_shipment_id/{external_shipment_id}](https://docs.shipstation.com/apis/openapi/labels/get_label_by_external_shipment_id.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Find a label by using the external shipment id that was used during label creation.

> Warning: This endpoint returns only the first label found with the specified external_shipment_id. If multiple labels share the same external_shipment_id, only the earliest created label will be returned. To retrieve all labels with a specific external_shipment_id, use the list labels endpoint with the external_shipment_id query parameter.

### Create a return label

 - [POST /v2/labels/{label_id}/return](https://docs.shipstation.com/apis/openapi/labels/create_return_label.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Create a return label for a previously created outbound label. The return label will automatically swap the ship to and ship from addresses from the original label.

### Get label tracking information

 - [GET /v2/labels/{label_id}/track](https://docs.shipstation.com/apis/openapi/labels/get_tracking_log_from_label.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Retrieve the label's tracking details.

### Void a label by id

 - [PUT /v2/labels/{label_id}/void](https://docs.shipstation.com/apis/openapi/labels/void_label.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Void a specific label using its label id. For labels that are paid for at time of label creation, this will also request a refund from the carrier.

### Cancel a label refund request

 - [POST /v2/labels/{label_id}/cancel_refund](https://docs.shipstation.com/apis/openapi/labels/cancel_label_refund.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Cancel a scheduled refund request for a label. Only labels with refund
status "request_scheduled" can be excluded from an upcoming refund request.

## Mailing

Create mailing labels for USPS including NetStamps, mail labels and envelopes.


### Create netstamps

 - [POST /v2/mailing/netstamps](https://docs.shipstation.com/apis/openapi/mailing/create_netstamps.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Create one or more NetStamps. Each shipment in the request produces an individual stamp
with optional row/column positioning via advanced_options.netstamps_options.

### Create mailing labels

 - [POST /v2/mailing/mail_labels](https://docs.shipstation.com/apis/openapi/mailing/create_mailing_labels.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Create one or more mailing labels on a sheet layout.
Use mailing_options to control which row and column to start printing from.

### Create envelope

 - [POST /v2/mailing/envelopes](https://docs.shipstation.com/apis/openapi/mailing/create_envelope.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Create a single envelope shipment.

## Manifests

A manifest is a document that provides a list of the day's shipments. It typically contains a barcode that allows the pickup driver to scan a single document to register all shipments, rather than scanning each shipment individually.


### List manifests

 - [GET /v2/manifests](https://docs.shipstation.com/apis/openapi/manifests/list_manifests.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Similar to querying shipments, we allow you to query manifests since there will likely be a large number over a long period of time.

### Create manifest

 - [POST /v2/manifests](https://docs.shipstation.com/apis/openapi/manifests/create_manifest.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Each ShipStation manifest is created for a specific warehouse, so you'll need to provide the warehouse_id
rather than the ship_from address. You can create a warehouse for each location that you want to create manifests for.

### Get manifest by id

 - [GET /v2/manifests/{manifest_id}](https://docs.shipstation.com/apis/openapi/manifests/get_manifest_by_id.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Get Manifest By Id

### Get manifest request by ID

 - [GET /v2/manifests/requests/{manifest_request_id}](https://docs.shipstation.com/apis/openapi/manifests/get_manifest_request_by_id.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Get Manifest Request By Id

## Package Pickups

Scheduled pickups and manage pickup requests for supported carriers.

### List scheduled pickups

 - [GET /v2/pickups](https://docs.shipstation.com/apis/openapi/package_pickups/list_scheduled_pickups.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

List all pickups that have been scheduled for this carrier

### Schedule a pickup

 - [POST /v2/pickups](https://docs.shipstation.com/apis/openapi/package_pickups/schedule_pickup.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Schedule a package pickup with a carrier

### Get pickup by id

 - [GET /v2/pickups/{pickup_id}](https://docs.shipstation.com/apis/openapi/package_pickups/get_pickup_by_id.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Get Pickup By ID

### Delete a scheduled pickup

 - [DELETE /v2/pickups/{pickup_id}](https://docs.shipstation.com/apis/openapi/package_pickups/delete_scheduled_pickup.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Delete a previously-scheduled pickup by ID

## Package Types

Create custom package types to use for your shipments, rather than the carriers' default package types.


### List custom package types

 - [GET /v2/packages](https://docs.shipstation.com/apis/openapi/package_types/list_package_types.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

List the custom package types associated with the account

### Create custom package type

 - [POST /v2/packages](https://docs.shipstation.com/apis/openapi/package_types/create_package_type.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Create a custom package type to better assist in getting accurate rate estimates

### Get custom package type by id

 - [GET /v2/packages/{package_id}](https://docs.shipstation.com/apis/openapi/package_types/get_package_type_by_id.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Get Custom Package Type by ID

### Update custom package type by id

 - [PUT /v2/packages/{package_id}](https://docs.shipstation.com/apis/openapi/package_types/update_package_type.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Update the custom package type object by ID

### Delete a custom package by id

 - [DELETE /v2/packages/{package_id}](https://docs.shipstation.com/apis/openapi/package_types/delete_package_typ.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Delete a custom package using the ID

## Products

Manage products in your ShipStation account. Products represent the items you sell and ship to customers.


### List products

 - [GET /v2/products](https://docs.shipstation.com/apis/openapi/products/listproducts.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans

## Purchase Orders

Create and manage purchase orders from suppliers to replenish inventory. Track order status, receive products, and update inventory levels automatically.


### List purchase orders

 - [GET /v2/purchase_orders](https://docs.shipstation.com/apis/openapi/purchase_orders/list_purchase_orders.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Retrieve a paginated list of purchase orders with optional filtering by status, warehouse, dates, and other criteria.

### Create a new purchase order

 - [POST /v2/purchase_orders](https://docs.shipstation.com/apis/openapi/purchase_orders/create_purchase_order.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Create a new purchase order with products from a supplier.

### Get purchase order details

 - [GET /v2/purchase_orders/{purchase_order_id}](https://docs.shipstation.com/apis/openapi/purchase_orders/get_purchase_order.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Retrieve detailed information about a specific purchase order including all products.

### Update a purchase order

 - [PUT /v2/purchase_orders/{purchase_order_id}](https://docs.shipstation.com/apis/openapi/purchase_orders/update_purchase_order.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Update an existing purchase order.

Editing limitations:
- In the draft status, all fields can be edited.
- Once a purchase order moves to any other status (open, receiving, received, cancelled, or closed),
updating via PUT is no longer allowed.
- For purchase orders in open status, use the POST /v2/purchase_orders/{purchase_order_id}/shipping_details endpoint to update shipping-related details.

### Update purchase order shipping details

 - [POST /v2/purchase_orders/{purchase_order_id}/shipping_details](https://docs.shipstation.com/apis/openapi/purchase_orders/update_purchase_order_shipping_details.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Update shipping-related details for a purchase order in open status.

Editing limitations:
- Once a purchase order moves to any higher status (receiving, received, cancelled, or closed),
updating shipping details is no longer allowed.
- Only the following fields can be modified: shipping_carrier, payment_terms, payment_status,
order_date, expected_delivery_date, note_to_supplier, tracking_number, currency_code, and reference_number.

### Update purchase order status

 - [POST /v2/purchase_orders/{purchase_order_id}/status](https://docs.shipstation.com/apis/openapi/purchase_orders/update_purchase_order_status.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Update the status of a purchase order. Valid status transitions must be followed.

### Receive purchase order products

 - [POST /v2/purchase_orders/{purchase_order_id}/receives](https://docs.shipstation.com/apis/openapi/purchase_orders/receives_purchase_order_products.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Record receipt of products from a purchase order. This updates inventory levels
and may automatically change purchase order status.

### Get purchase order summary PDF

 - [GET /v2/purchase_orders/{purchase_order_id}/documents/order_summary](https://docs.shipstation.com/apis/openapi/purchase_orders/get_purchase_order_summary_pdf.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Download a PDF document containing the purchase order summary.
Available for purchase orders with status: open, receiving, received, or closed.

### Get purchase order received summary PDF

 - [GET /v2/purchase_orders/{purchase_order_id}/documents/received_summary](https://docs.shipstation.com/apis/openapi/purchase_orders/get_purchase_order_received_summary_pdf.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Download a PDF document containing the received products summary.
Available for purchase orders with status: receiving, received, or closed.

## Rates

Quickly compare rates using the Rates endpoint. You can see and compare rates for the carriers connected to your account (as long as they support sending rates).


### Get shipping rates

 - [POST /v2/rates](https://docs.shipstation.com/apis/openapi/rates/calculate_rates.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

It's not uncommon that you want to give your customer the choice between whether they want to ship the fastest, cheapest, or the most trusted route. Most companies don't solely ship things using a single shipping option;
so we provide functionality to show you all your options!

### Get bulk rates

 - [POST /v2/rates/bulk](https://docs.shipstation.com/apis/openapi/rates/compare_bulk_rates.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Get Bulk Shipment Rates

### Estimate rates

 - [POST /v2/rates/estimate](https://docs.shipstation.com/apis/openapi/rates/estimate_rates.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Get Rate Estimates

### Get rate by id

 - [GET /v2/rates/{rate_id}](https://docs.shipstation.com/apis/openapi/rates/get_rate_by_id.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Retrieve a previously queried rate by its ID

## Service Points

Search for carrier service points (pickup and drop-off locations) where shipments can be delivered or picked up by customers.


### List service points

 - [POST /v2/service_points/list](https://docs.shipstation.com/apis/openapi/service_points/service_points_list.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

List carrier service points by location

### Get service point by ID

 - [GET /v2/service_points/{carrier_code}/{country_code}/{service_point_id}](https://docs.shipstation.com/apis/openapi/service_points/service_points_get_by_id.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Returns a carrier service point by using the service_point_id

## Shipments

Shipments are at the core of most ShipStation capabilities. Shipment objects are required for cretaing labels and manifests, as well as getting rates.


### List shipments

 - [GET /v2/shipments](https://docs.shipstation.com/apis/openapi/shipments/list_shipments.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Get list of Shipments

### Create shipments

 - [POST /v2/shipments](https://docs.shipstation.com/apis/openapi/shipments/create_shipments.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Create one or more shipments

### Assign user to shipments

 - [POST /v2/shipments/user](https://docs.shipstation.com/apis/openapi/shipments/assign_user_to_shipments.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Assigns a user to one or more shipments. You can assign a single user
to up to 500 shipments at once.

### Get shipment by external id

 - [GET /v2/shipments/external_shipment_id/{external_shipment_id}](https://docs.shipstation.com/apis/openapi/shipments/get_shipment_by_external_id.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Query Shipments created using your own custom ID convention using this endpoint

### Get shipment by id

 - [GET /v2/shipments/{shipment_id}](https://docs.shipstation.com/apis/openapi/shipments/get_shipment_by_id.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Get an individual shipment based on its ID

### Update a shipment

 - [PUT /v2/shipments/{shipment_id}](https://docs.shipstation.com/apis/openapi/shipments/update_shipment.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Update an existing shipment's details including addresses, package information,
carrier service, and shipping options. Use this endpoint to modify shipment
information before purchasing a label.

Note: The following fields are read-only and cannot be updated: shipment_id,
created_at, modified_at, shipment_status, tags, and total_weight.

### Cancel a shipment

 - [PUT /v2/shipments/{shipment_id}/cancel](https://docs.shipstation.com/apis/openapi/shipments/cancel_shipments.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Mark a shipment cancelled, if it is no longer needed or being used by your organized. Any label associated with the shipment needs to be voided first
An example use case would be if a batch label creation job is going to run at a set time and only queries pending shipments. Marking a shipment as cancelled
would remove it from this process

### Get shipment rates

 - [GET /v2/shipments/{shipment_id}/rates](https://docs.shipstation.com/apis/openapi/shipments/list_shipment_rates.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Get Rates for the shipment information associated with the shipment ID

### Get shipment tags

 - [GET /v2/shipments/{shipment_id}/tags](https://docs.shipstation.com/apis/openapi/shipments/shipments_list_tags.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Get Shipment tags based on its ID

### Add tag to shipment

 - [POST /v2/shipments/{shipment_id}/tags/{tag_name}](https://docs.shipstation.com/apis/openapi/shipments/tag_shipment.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Add a tag to the shipment object

### Remove tag from shipment

 - [DELETE /v2/shipments/{shipment_id}/tags/{tag_name}](https://docs.shipstation.com/apis/openapi/shipments/untag_shipment.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Remove an existing tag from the Shipment object

### Update internal notes for a shipment

 - [POST /v2/shipments/{shipment_id}/internal_notes](https://docs.shipstation.com/apis/openapi/shipments/update_shipment_internal_notes.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Update the internal notes on a shipment. You can either overwrite the existing
notes entirely or append new text to the current notes.

| Mode | note value | Result |
|------|-------------|--------|
| overwrite | "new note" | Replaces existing notes |
| overwrite | "" or " " | Clears the note |
| append | "new note" | Appends text to existing notes |

## Suppliers

Manage supplier information including contact details, email addresses, and physical addresses. Suppliers are used when creating purchase orders.


### List suppliers

 - [GET /v2/suppliers](https://docs.shipstation.com/apis/openapi/suppliers/list_suppliers.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Retrieve a paginated list of all suppliers with optional filtering by supplier name.

### Create a new supplier

 - [POST /v2/suppliers](https://docs.shipstation.com/apis/openapi/suppliers/create_supplier.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Create a new supplier with contact and address information.

### Get supplier details

 - [GET /v2/suppliers/{supplier_id}](https://docs.shipstation.com/apis/openapi/suppliers/get_supplier.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Retrieve detailed information about a specific supplier.

### Update a supplier

 - [PUT /v2/suppliers/{supplier_id}](https://docs.shipstation.com/apis/openapi/suppliers/update_supplier.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Update an existing supplier's information.

## Tags

Tags are text-based identifiers you can add to shipments to help in your shipment management workflows.


### Get tags

 - [GET /v2/tags](https://docs.shipstation.com/apis/openapi/tags/list_tags.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Get a list of all tags associated with an account.

### Create a new tag

 - [POST /v2/tags](https://docs.shipstation.com/apis/openapi/tags/create_tag.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Create a new tag for customizing how you track your shipments.

### Create a new tag

 - [POST /v2/tags/{tag_name}](https://docs.shipstation.com/apis/openapi/tags/create_tag_by_name.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Create a new Tag for customizing how you track your shipments

### Delete tag

 - [DELETE /v2/tags/{tag_name}](https://docs.shipstation.com/apis/openapi/tags/delete_tag.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Delete a tag that is no longer needed

### Update tag name

 - [PUT /v2/tags/{tag_name}/{new_tag_name}](https://docs.shipstation.com/apis/openapi/tags/rename_tag.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Change a tag name while still keeping the relevant shipments attached to it

## Totes

Manage totes (bins or containers) used in warehouse picking and packing operations. Create, update, delete totes and track tote quantities by warehouse.


### List totes

 - [GET /v2/totes](https://docs.shipstation.com/apis/openapi/totes/listtotes.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Get all totes for the seller, optionally filtered by warehouse.

### Create totes in batch

 - [POST /v2/totes](https://docs.shipstation.com/apis/openapi/totes/createtotesbatch.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Create multiple totes at once. Returns both successfully created totes and any failures.

### Get tote quantities

 - [GET /v2/totes/quantities](https://docs.shipstation.com/apis/openapi/totes/gettotequantities.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Get the number of totes in each warehouse.

### Get tote by ID

 - [GET /v2/totes/{tote_id}](https://docs.shipstation.com/apis/openapi/totes/gettotebyid.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Retrieve details of a specific tote.

### Update tote

 - [PUT /v2/totes/{tote_id}](https://docs.shipstation.com/apis/openapi/totes/updatetote.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Update the name or barcode of an existing tote.

### Delete tote

 - [DELETE /v2/totes/{tote_id}](https://docs.shipstation.com/apis/openapi/totes/deletetote.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Delete a tote by its ID.

## Tokens

Manage authentication tokens for accessing ShipStation services and dashboards.


### Get ephemeral token

 - [POST /v2/tokens/ephemeral](https://docs.shipstation.com/apis/openapi/tokens/tokens_get_ephemeral_token.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

This endpoint returns a token that can be passed to an application for authorized access. The lifetime of this token is 10 seconds.

## Tracking

Use the tracking endpoint to stop receiving tracking updates (more dedicated tracking endpoint methods coming soon).


### Get tracking information

 - [GET /v2/tracking](https://docs.shipstation.com/apis/openapi/tracking/get_tracking_log.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Retrieve package tracking information

### Start tracking a package

 - [POST /v2/tracking/start](https://docs.shipstation.com/apis/openapi/tracking/start_tracking.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Allows you to subscribe to tracking updates for a package. You specify the carrier_code and tracking_number of the package, and receive notifications via webhooks whenever the shipping status changes.

### Stop tracking a package

 - [POST /v2/tracking/stop](https://docs.shipstation.com/apis/openapi/tracking/stop_tracking.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Unsubscribe from tracking updates for a package.

## Warehouses

Get warehouse details like warehouse ID and related addresses using the warehouses endpoint.


### List warehouses

 - [GET /v2/warehouses](https://docs.shipstation.com/apis/openapi/warehouses/list_warehouses.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Retrieve a list of warehouses associated with this account.

### Create warehouse

 - [POST /v2/warehouses](https://docs.shipstation.com/apis/openapi/warehouses/create_warehouse.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Create a warehouse location that you can use to create shipping items by simply passing in the generated warehouse id. If the return address is not supplied in the request body then it is assumed that the origin address is the return address as well

### Get warehouse by id

 - [GET /v2/warehouses/{warehouse_id}](https://docs.shipstation.com/apis/openapi/warehouses/get_warehouse_by_id.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Retrieve warehouse data based on the warehouse ID

### Update warehouse by ID

 - [PUT /v2/warehouses/{warehouse_id}](https://docs.shipstation.com/apis/openapi/warehouses/update_warehouse.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Update Warehouse object information

### Delete warehouse by ID

 - [DELETE /v2/warehouses/{warehouse_id}](https://docs.shipstation.com/apis/openapi/warehouses/delete_warehouse.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Delete a warehouse by ID

### Update warehouse settings

 - [PUT /v2/warehouses/{warehouse_id}/settings](https://docs.shipstation.com/apis/openapi/warehouses/update_warehouse_settings.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Update Warehouse settings object information

## Users

Manage and retrieve user information for the ShipStation account. This endpoint allows you to list users with various filtering options.


### List users

 - [GET /v2/users](https://docs.shipstation.com/apis/openapi/users/listusers.md): Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans

## Webhooks

Webhooks are a powerful feature that can save you from sending repeated polling requests to check on the state of something. With webhooks, ShipStation will automatically contact your servers when the stage changes. This can include parcel tracking events, notification when a batch operation completes, and more.


### List webhooks

 - [GET /v2/environment/webhooks](https://docs.shipstation.com/apis/openapi/webhooks/list_webhooks.md): Products
            Plans
          
        
        
          
            
              
[...]
